package com.prank.tool.frag;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.GridLayoutManager;

import com.prank.tool.act.ActivityRecorder;
import com.prank.tool.act.ActivitySave;
import com.prank.tool.adapter.AdapterLike;
import com.prank.tool.databinding.FragmentRecorderBinding;
import com.prank.tool.interf.OnImportListener;
import com.prank.tool.jbean.Info;
import com.prank.tool.popu.PopRecorder;
import com.prank.tool.top.AdManager;
import com.prank.tool.top.onActionListener;
import com.prank.tool.utils.DbManager;
import com.prank.tool.utils.Space;
import com.prank.tool.utils.Tools;

import java.util.List;
import java.util.Map;


public class FragmentRecorder extends Fragment implements View.OnClickListener , OnImportListener {

    private FragmentRecorderBinding binding;
    private AdapterLike adapter;
    private ActivityResultLauncher<String> requestRecordAudioLauncher;
    private ActivityResultLauncher<String> audioPickerLauncher;
    private ActivityResultLauncher<String[]> requestStorePermissionsLauncher;
    private PopRecorder popRecorder;
    public FragmentRecorder() {

    }

    public static FragmentRecorder newInstance() {
        FragmentRecorder fragment = new FragmentRecorder();
        Bundle args = new Bundle();

        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        requestRecordAudioLauncher = registerForActivityResult(
                new ActivityResultContracts.RequestPermission(),
                isGranted -> {
                    if (isGranted) {
                        intentRecordAudio();
                    } else {
                        Toast.makeText(requireContext(), "Recording permission denied", Toast.LENGTH_SHORT).show();
                    }
                }
        );

        requestStorePermissionsLauncher = registerForActivityResult(
                new ActivityResultContracts.RequestMultiplePermissions(),
                new ActivityResultCallback<Map<String, Boolean>>() {
                    @Override
                    public void onActivityResult(Map<String, Boolean> result) {
                        Boolean isGranted = true;
                        for (Map.Entry<String, Boolean> entry : result.entrySet()) {
                            String permission = entry.getKey();
                            isGranted = entry.getValue();
                            if(!entry.getValue()){
                                isGranted = false;
                            }

                        }
                        if (isGranted) {
                            importAudio();
                        }else {
                            Toast.makeText(requireContext(),   " 权限被拒绝", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
        );
        audioPickerLauncher = registerForActivityResult(new ActivityResultContracts.GetContent(),
                new ActivityResultCallback<Uri>() {
                    @Override
                    public void onActivityResult(Uri uri) {
                        // Handle the returned Uri

                        if (uri != null) {
                            long duration = Tools.getAudioDuration(requireContext(), uri);
                            Intent intent = new Intent(requireContext(), ActivitySave.class);
                            intent.putExtra(ActivitySave.KEY_Path, uri.toString());
                            intent.putExtra(ActivitySave.KEY_Time, duration);
                            startActivity(intent);
                        }
                    }
                });
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragmentRecorderBinding.inflate(getLayoutInflater());

        binding.menu.setOnClickListener(this);
        Space itemHelper = new Space(10, 10, 5);
        binding.recyclerImport.addItemDecoration(itemHelper);
        binding.recyclerImport.setLayoutManager(new GridLayoutManager(requireContext(), 2));
        List<Info> all = DbManager.getAllCustomization();
        updateUi(all);
        adapter = new AdapterLike(requireContext(), all,true);
        binding.recyclerImport.setAdapter(adapter);


        return binding.getRoot();
    }


    public void refresh() {
        if (adapter != null) {
            List<Info> all = DbManager.getAllCustomization();
            updateUi(all);
            adapter.updateData(all);
        }

    }

    private void updateUi(List<Info> all) {
        if (all.size() == 0) {
            binding.noImportHint.setVisibility(View.VISIBLE);
            binding.recyclerImport.setVisibility(View.GONE);
        } else {
            binding.noImportHint.setVisibility(View.GONE);
            binding.recyclerImport.setVisibility(View.VISIBLE);
        }
    }

    private void checkAndRequestAudioPermission() {
        if (ContextCompat.checkSelfPermission(requireContext(), Tools.permission_record_audio)
                != PackageManager.PERMISSION_GRANTED) {
            requestRecordAudioLauncher.launch(Tools.permission_record_audio);
        } else {
            intentRecordAudio();
        }
    }

    private void intentRecordAudio() {
        Intent intent = new Intent(requireContext(), ActivityRecorder.class);
        startActivity(intent);
    }

    @Override
    public void onClick(View v) {
         if(v.equals(binding.menu)){
             if (popRecorder == null) {
                 popRecorder = new PopRecorder(requireActivity(), this);
             }
             AdManager.showTopOn(requireActivity(), new onActionListener() {
                 @Override
                 public void onAction() {
                     popRecorder.showBottom(binding.menu);
                 }
             });

        }
    }



    private void importAudio() {
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.setType("audio/*");
        audioPickerLauncher.launch("audio/*");

    }


    @Override
    public void onClickTimerListener(int type) {
        switch (type){
            case 0:
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                    if (ContextCompat.checkSelfPermission(requireContext(), Tools.permission_read_audio[0])
                            != PackageManager.PERMISSION_GRANTED) {
                        requestStorePermissionsLauncher.launch(Tools.permission_read_audio);
//                    ActivityCompat.requestPermissions(requireActivity(), ConstValues.permission_read_audio,
//                            ConstValues.REQUEST_READ_STORAGE_PERMISSION);
                    } else {
                        importAudio();
                    }
                } else {
                    if (ContextCompat.checkSelfPermission(requireContext(), Manifest.permission.WRITE_EXTERNAL_STORAGE)
                            != PackageManager.PERMISSION_GRANTED ||
                            ContextCompat.checkSelfPermission(requireContext(), Manifest.permission.READ_EXTERNAL_STORAGE)
                                    != PackageManager.PERMISSION_GRANTED) {
                        requestStorePermissionsLauncher.launch(Tools.permission_store);
//                    ActivityCompat.requestPermissions(requireActivity(), ConstValues.permission_store, ConstValues.REQUEST_READ_STORAGE_PERMISSION);
                    } else {
                        importAudio();
                    }
                }
                break;
            case 1:
                checkAndRequestAudioPermission();
                break;
        }
    }
}